/*
 * Logger.h
 *
 *  Created on: Nov 1, 2010
 *      Author: halsafar
 */

#ifndef LOGGER_H_
#define LOGGER_H_

#include <memory>
#include <iostream>

#include "ILogger.h"
#include "NetLogger.h"


// LOGGER FACTORY, ONE INSTANCE
class Logger
{
public:
	static ILogger& GetLogger();
private:
	static std::auto_ptr<ILogger> _netLogger;
};

// Defines used for completely abstract use of the logger subsystem

#ifdef CELL_DEBUG
	#define LOG_INIT() Logger::GetLogger().init()
#else
	#define LOG_INIT()
#endif


#ifdef CELL_DEBUG
	#define LOG_CLOSE() Logger::GetLogger().close()
#else
	#define LOG_CLOSE()
#endif


#ifdef CELL_DEBUG
	#define LOG(fmt, args...) Logger::GetLogger().printf(fmt, ##args)
#else
	#define LOG(fmt, args...)
#endif

#endif /* LOGGER_H_ */
