#ifndef __NETWORK_TCPSOCKET_HPP
#define __NETWORK_TCPSOCKET_HPP

#include <stddef.h>
#include <stdint.h>
#include <string>
#include "Socket.hpp"

namespace Network {

   class TCPSocket : public Socket
   {
      public:
         TCPSocket(const std::string& host, uint16_t port, bool blocking = true, int timeout = 3000);
         TCPSocket(int fd);

         ssize_t recv(void *buf, size_t bytes);
         ssize_t send(const void *buf, size_t bytes);
         ssize_t send(const std::string& msg);
         ssize_t send(const char *msg);

      private:
         void operator=(const TCPSocket&); // Can't copy a socket
   };

   class TCPServerSocket : public Socket
   {
      public:
         TCPServerSocket(uint16_t port, bool blocking = true);
         TCPSocket accept() const;
      private:
         TCPServerSocket(const TCPServerSocket&); // Can't copy a socket
         void operator=(const TCPServerSocket&);
   };
}

#endif
