#include "network.hpp"
#include <cell/sysmodule.h>
#include <netex/net.h>

namespace Network {

NetworkInterface::NetworkInterface()
{
   if (ref() == 0)
   {
      int rc;
      rc = cellSysmoduleLoadModule(CELL_SYSMODULE_NET);
      rc = sys_net_initialize_network();
   }
   ref()++;
}

NetworkInterface::~NetworkInterface()
{
   if (ref() == 1)
   {
      sys_net_finalize_network();
      cellSysmoduleUnloadModule(CELL_SYSMODULE_NET);
   }
   ref()--;
}

}
