#include "TestAudio.hpp"
#include <vector>
#include <fastmath.h>

TestAudio::TestAudio() : audio(new Audio::AudioPort<int16_t>(2, 48000))
{}

void TestAudio::start()
{
   running = true;
   thread = new Threads::Thread(&TestAudio::audio_thread, this);
}

void TestAudio::stop()
{
   running = false;
   thread->join();
}

TestAudio::~TestAudio()
{
   delete thread;
   delete audio;
}

void TestAudio::audio_thread()
{
   uint64_t cnt = 0;
   std::vector<int16_t> buf(1024);
   while (running)
   {
      for (unsigned i = 0; i < buf.size(); i+=2)
      {
         buf[i] = (int16_t)(0x7FFE * sin(cnt * 0.01));
         buf[i+1] = (int16_t)(0x7FFE * sin(cnt * 0.01));
         cnt++;
      }
      audio->write(&buf[0], buf.size());
   }
}
