#include "emulator_audio.h"

bool Audio_Init()
{
   return cellAudioPortInit();
}

uint64_t Audio_Write(const int16_t* buffer, uint64_t samples)
{
   return cellAudioPortWrite(buffer, samples);
}

bool Audio_Blocking()
{
   return cellAudioPortBlocking();
}

bool Audio_ContinueBlocking()
{
   return cellAudioPortContinueBlocking();
}

void Audio_ChangeResamplingFrequency(int newsamplefreq)
{
	Audio_Exit();
	Audio_Init(newsamplefreq);
}

void Audio_Exit()
{
   cellAudioPortExit();
}

void Audio_Pause()
{
   cellAudioPortPause();
}

void Audio_Resume()
{
   cellAudioPortResume();
}
