/*
 * menu.h
 *
 *  Created on: Oct 10, 2010
 *      Author: halsafar
 */

#ifndef MENU_H_
#define MENU_H_

#include "colors.h"

#define MAX_PATH 1024

//lidbgfont
#define FONT_SIZE 1.0f

// if you add more settings to the screen, remember to change this value to the correct number
// PATH - Total amount of Path settings
#define MAX_NO_OF_PATH_SETTINGS 4
//SNES9x - Total amount of SNES9x settings
#define MAX_NO_OF_SNES9X_SETTINGS      12
//GENERAL - Total amount of settings
#define MAX_NO_OF_SETTINGS      10

//SNES9X  - setting constants
#define SETTING_DISPLAY_FRAMERATE 0
#define SETTING_SOUND_INPUT_RATE 1
#define SETTING_TRANSPARENCY 2
#define SETTING_SKIP_FRAMES 3
#define SETTING_DISABLE_GRAPHIC_WINDOWS 4
#define SETTING_DISPLAY_PRESSED_KEYS 5
#define SETTING_FORCE_PAL 6
#define SETTING_FORCE_NTSC 7
#define SETTING_PAL_TIMING 8
#define SETTING_AUTO_APPLY_CHEATS 9
#define SETTING_AUTO_APPLY_PATCH 10
#define SETTING_DEFAULT_SNES9X_ALL 11

//GENERAL - setting constants
#define SETTING_CURRENT_SAVE_STATE_SLOT 0
#define SETTING_CHANGE_RESOLUTION 1
#define SETTING_PAL60_MODE 2
#define SETTING_CURRENT_SHADER 3
#define SETTING_KEEP_ASPECT_RATIO 4
#define SETTING_HW_TEXTURE_FILTER 5
#define SETTING_HW_OVERSCAN_AMOUNT 6
#define SETTING_RSOUND_ENABLED 7
#define SETTING_RSOUND_SERVER_IP_ADDRESS 8
#define SETTING_DEFAULT_ALL 9

//PATH - setting constants
#define SETTING_PATH_DEFAULT_ROM_DIRECTORY 0
#define SETTING_PATH_SAVESTATES_DIRECTORY 1
#define SETTING_PATH_CHEATS 2
#define SETTING_PATH_DEFAULT_ALL 3

void MainMenu(void);

void MenuStop();
bool MenuIsRunning();
char* MenuGetSelectedROM();
char* MenuGetCurrentPath();
char* do_pathmenu(uint16_t is_for_shader_or_dir_selection, const char * pathname = "/");

#endif /* MENU_H_ */
